<?php
namespace Teknisa\MAN\Controllers;

use Teknisa\MAN\Services\ItensService;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;


class Itens extends CrudWithParameterBag {
    protected $dataSourceName = 'itens';
    protected $dataSourceNameToFind = 'produtoitem';
    protected $dataSourceNameToFind5 = 'produtoitemfilter';
    protected $dataSourceNameToFilterInicial = 'produtoitemfilterinicial';
    protected $dataSourceNameToFilterFinal = 'produtoitemfilterfinal';
    protected $dataSourceNameToFind2 = 'listaProdutosSelect';
    protected $dataSourceNameToFind3 = 'listaProdutosSelectFilterInicial';
    protected $dataSourceNameToFind4 = 'listaProdutosSelectFilterFinal';
    /**
     * @var itensService
     */
    protected $itensService;
    protected $parameterBagColumns = array('NRORG', 'CDTABEPREC', 'PRODINICIAL', 'PRODFINAL', 'CDFILIALTABPREC', 'CDNVPRODUTO');

    public function __construct (Manager $dataSourceManager, ItensService $itensService, ParameterBag $parameterBag) {
        $this->itensService = $itensService;
        parent::__construct($dataSourceManager, $parameterBag);
    }

    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        foreach($request->getDataSet()->getRows() as &$linha) {
            foreach($linha as &$row){
                if(!isset($row['CDPRPAITABPR'])) {
                    $row['CDPRPAITABPR'] = $row['CDPRODUTO'];
                }
                if(isset($row['__save'])) {
                    if($row['__save']) {
                        $row['__is_new'] = $this->itensService->defineIsNew($row['CDFILIAL'], $row['CDTABEPREC'], $row['DTINIVGPREC'], $row['CDPRODUTO'], $row['CDPRPAITABPR'], $row['NRORG']);
                        $explodedVrprecitem = explode(',', $row['VRPRECITEM']);
                        $explodedVrprecitemcl = explode(',',$row['VRPRECITEMCL']);
                        if(count($explodedVrprecitem) == 3){
                            unset($explodedVrprecitem[2]);
                            $row['VRPRECITEM'] = implode(',',$explodedVrprecitem);
                        }
                        if(count($explodedVrprecitemcl) == 3){
                            unset($explodedVrprecitemcl[2]);
                            $row['VRPRECITEMCL'] = implode(',',$explodedVrprecitemcl);
                        }
                        if($row['__is_new']) {
                            $row['DTINCLUSAO'] = date("d/m/Y H:i:s");
                            $this->dataSourceManager->persist(new DataSet('itensSave',array($row))); 
                        } else if(!$row['__is_new']){
                            $row['DTULTATU'] = date("d/m/Y H:i:s");
                            $this->dataSourceManager->persist(new DataSet('itensSaveAtu', array($row)));
                        }
                        $response->addNotification(new Notification("Salvo com sucesso.", Notification::TYPE_SUCCESS));
                    }
                }
            }
        }
        $this->dataSourceName = 'itens';
    }

    public function findProduct(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameToFind2;
        parent::find($request, $response);
    }

    public function findProductInicial(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameToFind3;
        parent::find($request, $response);
    }

    public function findProductFinal(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameToFind4;
        parent::find($request, $response);
    }

    public function filtrarProdutos(DTO\Request\Filter $request, DTO\Response $response) {
       $filterData = $request->getFilterCriteria();
    }
}