<?php    
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelAuditoriaLancMesa  {

    protected $RelAuditoriaLancMesa;
    protected $utilService;
    
    public function __construct(Services\RelAuditoriaLancMesaService $RelAuditoriaLancMesaService, Utilities\Util $utilService) {
        $this->RelAuditoriaLancMesaService = $RelAuditoriaLancMesaService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $conditions = $this->utilService->getParamsAsArray($request);
        $conditions = $this->buildParams($conditions);
        $result = $this->RelAuditoriaLancMesaService->find($conditions);

        $response->addDataSet(new DataSet("RelAuditoriaLancMesa", $result));
        return $response;
    }
    
    
    public function buildParams($conditions){
        if(!array_key_exists('CDFILIAL', $conditions)) {
            $conditions['CDFILIAL'] = '';
            $conditions['TCDFILIAL'] = 'T';
        } else {
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            $conditions['TCDFILIAL'] = '';
        }
        if(!array_key_exists('CDLOJA', $conditions)) {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        } else {
            $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $conditions['TCDLOJA'] = '';
        }
        if(!array_key_exists('GARCOM', $conditions)) {
            $conditions['CDVENDEDOR'] = '';
            $conditions['TCDVENDEDOR'] = 'T';
        } else {
            $conditions['CDVENDEDOR'] = implode('_', $conditions['GARCOM']);
            $conditions['TCDVENDEDOR'] = '';
        }
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DTINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        if(!array_key_exists('MESA', $conditions)) {
            $conditions['NRMESA'] = '';
            $conditions['TNRMESA'] = 'T';
        } else {
            $conditions['NRMESA'] = implode('_', $conditions['MESA']);
            $conditions['TNRMESA'] = '';
        }
        return $conditions;
    }
    
}