<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class Estrutura {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function insereTipoEstrutura($NRTIPOESTRUTURA, $NMTIPOESTRUTURA, $NRORG){
		$params = array(
			':NRTIPOESTRUTURA' => $NRTIPOESTRUTURA,
			':NMTIPOESTRUTURA' => $NMTIPOESTRUTURA,
			':NRORG' => $NRORG
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_TIPO_ESTRUTURA, $params);
	}

	public function insereEstrutura($NRESTRUTURAM, $NRORG, $NRTIPOESTRUTURA, $NMESTRUTURAM, $CDINTESTRUTURA){
		$params = array(
			':NRESTRUTURAM' => $NRESTRUTURAM,
			':NRORG' => $NRORG,
			':NRTIPOESTRUTURA' => $NRTIPOESTRUTURA,
			':NMESTRUTURAM' => $NMESTRUTURAM,
			':CDINTESTRUTURA' => $CDINTESTRUTURA
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_ESTRUTURA, $params);
	}

	public function insereHierarquia($NRHIERARQUIAORG, $NRORG, $NRTIPOHIERARQORG, $NRESTRUTURAMSUP, $NRESTRUTURAMREL){
		$params = array(
			':NRHIERARQUIAORG' => $NRHIERARQUIAORG,
			':NRORG' => $NRORG,
			':NRTIPOHIERARQORG' => $NRTIPOHIERARQORG,
			':NRESTRUTURAMSUP' => $NRESTRUTURAMSUP,
			':NRESTRUTURAMREL' => $NRESTRUTURAMREL
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_HIERARQUIA, $params);
	}

	public function insereTipoHierarquia($NRTIPOHIERARQORG, $NMTIPOHIERARQORG, $NRTIPOESTRUTREL, $NRTIPOESTRUTSUP, $NRORG) {
		$params = array(
			':NRTIPOHIERARQORG' => $NRTIPOHIERARQORG,
			':NMTIPOHIERARQORG' => $NMTIPOHIERARQORG,
			':NRTIPOESTRUTREL' => $NRTIPOESTRUTREL,
			':NRTIPOESTRUTSUP' => $NRTIPOESTRUTSUP,
			':NRORG' => $NRORG
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_TIPO_HIERARQUIA, $params);
	}

	public function buscaTiposEstrutura(){
		$params = array();
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TIPOS_ESTRUTURA, $params);
	}

	public function buscaEstruturas($NRTIPOESTRUTSUP){
		$params = array(
			':NRTIPOESTRUTSUP' => $NRTIPOESTRUTSUP
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_ESTRUTURAS, $params);
	}

	public function buscaTiposHierarquia($NRTIPOESTRUTREL){
		$params = array(
			':NRTIPOESTRUTREL' => $NRTIPOESTRUTREL
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TIPOS_HIERARQUIA, $params);
	}

	public function buscaTiposHierarquiaSemFiltro(){
		$params = array();
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TIPOS_HIERARQUIA_SEM_FILTRO, $params);
	}

	public function buscaEstruturasHieraquizadas(){
		$params = array();
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_ESTRUTURAS_HIERARQUIZADAS, $params);
	}
	public function excluiEstrutura($NRESTRUTURAM){
		$params = array(
			':NRESTRUTURAM' => $NRESTRUTURAM
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_ESTRUTURA, $params);
	}

	public function excluiHierarquia($NRESTRUTURAM){
		$params = array(
			':NRESTRUTURAM' => $NRESTRUTURAM
		);
		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_HIERARQUIA_ESTRUTURA, $params);
	}

	public function buscaFilhosEstrutura($NRESTRUTURAMREL){
		$params = array(
			':NRESTRUTURAMREL' => $NRESTRUTURAMREL
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_FILHOS_ESTRUTURA, $params);	
	}

	public function refazHierarquia($NRESTRUTURAM, $NRESTRUTURAMSUP){
		$params = array(
			':NRESTRUTURAM' => $NRESTRUTURAM,
			':NRESTRUTURAMSUP' => $NRESTRUTURAMSUP
		);
		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_ESTRUTURA_SUPERIOR, $params);	
	}

	public function alteraNomeEstrutura($NRESTRUTURAM, $NMESTRUTURAM){
		$params = array(
			':NRESTRUTURAM' => $NRESTRUTURAM,
			':NMESTRUTURAM' => $NMESTRUTURAM
		);
		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_NOME_ESTRUTURA, $params);
	}

	public function alteraEstruturaPai($NRESTRUTURAM, $NRESTRUTURAMSUP, $NRTIPOHIERARQORG){
		$params = array(
			':NRESTRUTURAMSUP' => $NRESTRUTURAMSUP,
			':NRESTRUTURAM' => $NRESTRUTURAM,
			':NRTIPOHIERARQORG' => $NRTIPOHIERARQORG
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_ESTRUTURA_PAI, $params);
	}

	public function buscaEstruturaOperador($NRESTRUTURAM){
		$params = array(
			':NRESTRUTURAM' => $NRESTRUTURAM
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_ESTRUTURAOOPER_PELA_ESTRUTURA, $params);
	}

	public function buscaOrganizacaoOperador($NRORGANIZACAOOPER, $NRORG){
		$params = array(
			':NRORGANIZACAOOPER' => $NRORGANIZACAOOPER,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_ORGANIZACAOPER, $params);
	}

	public function buscaOperadorOrganizacao($CDOPERADOR){
		$params = array(
			':CDOPERADOR' => $CDOPERADOR
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_OPERADOR_LIAGADO_ESTRUTURA, $params);
	}

	public function buscaOperadoresAssociar($NMOPERADOR, $FIRST, $LAST){
		$params = array(
			':NMOPERADOR' => $NMOPERADOR,
			':FIRST' => $FIRST,
			':LAST' => $LAST
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_OPERADORES_ASSOCIAR, $params);
	}

	public function insertOrganizacaoOperador($CDOPERADOR, $NRORGANIZACAOOPER , $NRORGREL){
		$params = array(
			':CDOPERADOR' => $CDOPERADOR,
			':NRORGANIZACAOOPER' => $NRORGANIZACAOOPER,
			':NRORGREL' => $NRORGREL 
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_ORGANIZACAO_OPERADOR, $params);
	}

	public function insertEstruturaOperador($NRESTRUTURAOPER, $NRORGANIZACAOOPER , $NRESTRUTURAMREL){
		$params = array(
			':NRESTRUTURAOPER' => $NRESTRUTURAOPER,
			':NRORGANIZACAOOPER' => $NRORGANIZACAOOPER,
			':NRESTRUTURAMREL' => $NRESTRUTURAMREL 
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_ESTRUTURA_OPERADOR, $params);
	}

	public function buscaOrgOperador($CDOPERADOR, $NRORGREL){
		$params = array(
			':CDOPERADOR' => $CDOPERADOR, 
			':NRORGREL' => $NRORGREL 
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_ORGANIZACAOOPER, $params);
	}


	public function excluiAssociacaoOperador($NRESTRUTURAMREL, $NRORGANIZACAOOPER){
		$params = array(
			':NRESTRUTURAMREL' => $NRESTRUTURAMREL, 
			':NRORGANIZACAOOPER' => $NRORGANIZACAOOPER 
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_ASSOCIACAO_OPERADOR_ESTRUTURA, $params);
	}

	public function buscaOperAssociados($NRESTRUTURAMREL){
		$params = array(
			':NRESTRUTURAMREL' => $NRESTRUTURAMREL
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_OPERADORES_ASSOCIADOS, $params);
	}


}